; ******************************************************
; BASIC .ASM template file for AVR
; ******************************************************

.include "C:\VMLAB\include\2313def.inc"
.cseg
.org 0
rjmp Reset
rjmp INT_0
rjmp INT_1
rjmp Timer1_capt1
rjmp Timer1_comp1
rjmp Timer1_OVF1
rjmp Timer0_OVF0
rjmp UART_RX
rjmp UART_UDRE
rjmp UART_TX
rjmp ANA_COMP

INT_0:
INT_1:
Timer1_capt1:
Timer1_comp1:
Timer1_OVF1:
Timer0_OVF0:
UART_RX:
UART_UDRE:
UART_TX:
ANA_COMP:
          reti



; Define here the variables
;
.def	Ref=R15
.def     	Temp2=R16
.def     	Temp3=R17
.def     	K1=R18
.def	K2=R19
.def	K3=R20
.def	K4=R21
.def     	Cot=R22
.def     	TempB=R23
;.def     	TempD=R24
.def	D=R24
.def	AS=R25

Reset:

   	ldi Tempb,0b11111111   ;    
	out DDRB,TempB         ; B   
	subi TempB,1
   	out DDRD,TempB         ; PD0  ,  PD  

Nod:
	
   	ldi D,68                ;     
  	mov Ref,D
   	out PortB,TempB         ;-   
	out PortD,TempB

Start:


   	clr K1
   	clr K3
   	clr K2
   	clr K4
   	clr Temp3

Begin:

  	in AS,PinD                ;  
      								
Int:

   	in cot,PinD               ;,   ?
   	cp AS,Cot                 ;    1
   	breq int

Cop1:

	sbic PinD,0               ;   ?
	rjmp Begin                ;  1  0    Begin,   Int2
	
;*********************************************************
;  	
;*********************************************************
	
;*********************************************************
;    0  1   
;*********************************************************

Int2:

   	inc K1                   ;  ()
   	cp K1,Ref ;0xff          ;      ()
   	breq Res1                ;        

Cop2:

   	sbis PinD,0              ;   0  1
   	rjmp int2                ;        Int2
                          		  ;  
;********************************************************
;    1  0     
;********************************************************

Int3:

  	inc K1                   ;   ()
   	cp K1,Ref ;0xff          ;      ()
   	breq Res2                ;        

Cop3:

   	sbic PinD,0              ;   1  0
   	rjmp Int3                ;        Int3
   	rjmp Kup                 ;     Kup

;********************************************************
;    
;********************************************************

Res1:
   	clr K1
   	inc K2
   	cp K2,Ref
   	breq Res3
   	rjmp Int2

Res2:
   	clr K1
   	inc K2
   	cp K2,Ref
   	breq Res4
   	rjmp Int3

Res3:
   	clr K2
   	inc K3
   	cp K3,Ref
   	breq Ind               ;         
   	rjmp Int2

Res4:
   	clr K2
   	inc K3
   	cp K3,Ref
   	breq Ind               ;          
   	rjmp Int3

;********************************************************
;      
;********************************************************


Kup:

	inc K4
	cpi K4,48              ;    48  
   	brlo Int2

Kup2:

   	rjmp Start             ;  Start

;********************************************************
; 
;********************************************************


Ind:	
   	clr K1
	
IndB:

   	mov Cot,K4                    ; 
   	ldi ZH,High(MyA*2)            ; ,
   	ldi ZL,Low(MyA*2)             ;   ,
   	ldi AS,0                      ;,  
	add ZL,Cot                    ;    MyA
   	adc ZH,AS                     ;  ,  
                                 ;   
	lpm                           ;   4
	                              ;
   	mov AS,R0                     ;
   	out PortB,AS                  ;
   	clr R30                       ;
   	clr R31                       ;

IndD:

   	mov Cot,K4                    ;   , 
   	ldi ZH,High(MyB*2)            ;  MyB
   	ldi ZL,Low(MyB*2)             ;
   	ldi AS,0                      ;..   4 
	add ZL,Cot                    ; ,      D
   	adc ZH,AS                     ;   
                                 ;  MyA  MyB (128  62)
  	lpm
  	
   	mov AS,R0
   	out PortD,AS
   	clr R30
   	clr R31

 	
	rjmp Start                    ;     


MyA:

.db 128,192,224,240,248,252,254,255,128,192,224,240,248,252,254,255
.db 128,192,224,240,248,252,254,255,128,192,224,240,248,252,254,255
.db 128,192,224,240,248,252,254,255,128,192,224,240,248,252,254,255


MyB:

.db 62,62,62,62,62,62,62,62,94,94,94,94,94,94,94,94
.db 110,110,110,110,110,110,110,110,118,118,118,118,118,118,118,118
.db 122,122,122,122,122,122,122,122,124,124,124,124,124,124,124,124
